
	;	requires tmp0,1 & 2 temporary working files.

	;	results are stored in dssign and dsmag files.

	;	dssign is 0 if temp is +ve, ff if temp -ve.
	;	dsmag contains the 8 bit temperature reading
	;	lsb = .5 degrees c, see dallas data sheet.

	;	just call newtemp every time round in your
	;	main loop and test the W reg to see if
	;	new data is available.

	;	note parts of this code are timing critical
	;	and must be run with interrupts turned off!
	;	see the intson and intsoff macros below.


; ---------------------------------------------------------

	;	ds1820 macros

intson:		macro
	bcf		INTCON, GIE		;liga interrupcoes
	endm


intsoff:	macro
	bcf		INTCON, GIE		;desliga interrupcoes
	endm



dqlow:	macro
	bcf	PORTB,dsbit	; dq bit ready low
	bsf	STATUS,RP0
	bcf	TRISB,dsbit	; dq bit now o/p
	bcf	STATUS,RP0
	endm


dqhiz:	macro
	bsf	STATUS,RP0
	bsf	TRISB,dsbit	; dq bit now i/p
	bcf	STATUS,RP0
	endm


dqlow_2:	macro
	bcf	PORTB,dsbit_2; dq bit ready low
	bsf	STATUS,RP0
	bcf	TRISB,dsbit_2; dq bit now o/p
	bcf	STATUS,RP0
	endm


dqhiz_2:	macro
	bsf	STATUS,RP0
	bsf	TRISB,dsbit_2	; dq bit now i/p
	bcf	STATUS,RP0
	endm


; ---------------------------------------------------------


newtemp:

	intsoff		;desliga interrupcoes

	clrf	tmp0
	clrf	tmp1
	clrf	tmp2

getemp:
	
	call	dsreset
	movlw	h'cc'		; skip prom
	call	dstx8
	movlw	h'44'		; start convert temperatura
	call	dstx8


;; delay de pull-up forcado
	dqlow				;faz pull-up forcado
	bsf		PORTB,dsbit	; dq bit ready HIGH
	bsf		PORTB,dsbit	; dq bit ready HIGH
	bsf		PORTB,dsbit	; dq bit ready HIGH
	bsf		PORTB,dsbit	; dq bit ready HIGH
	bsf		PORTB,dsbit	; dq bit ready HIGH
	call	del_500		;pausa de 1seg
	call	del_500	
	dqhiz				;desfaz pull-up forcado
	
	call	dsreset		;outra vez reset
	movlw	h'cc'		; skip prom
	call	dstx8
	movlw	h'be'		; read scratch pad
	call	dstx8

	call	dsrx8		; magnitude
	movwf	dsmag
	call	dsrx8		; sign (ff=-ve, 00=+ve)
	movwf	dssign

	call	dsreset		; seen enough, restart


fim_1wire:
	
	intson		;liga ints

	return













; ------------------------------------------------------------

	;	ds1820 subroutines

dsreset:

	dqlow
	call	del_100u	;pausa de 600us
	call	del_100u
	call	del_100u
	call	del_100u
	call	del_100u
	call	del_100u
	dqhiz

	call	del_10u		;pausa 70us
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;

	call	del_100u	;pausa de 300us
	call	del_100u
	call	del_100u

	return




dstx8:	
	movwf	tmp2		; data to tx
	movlw	8
	movwf	tmp1		; loop counter
dstxlp:	

	dqlow
	call	del_10u		;pausa 10us
	
	rrf		tmp2, F
	btfsc	STATUS,C
	 bsf	PORTB,dsbit	; dq hi if bit was 1

	call	del_10u		;pausa 70us
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;
	dqhiz

	nop		;6us
	nop
	nop
	nop
	nop
	nop

	decfsz	tmp1, F
	 goto	dstxlp

	return




dsrx8:
	movlw	8
	movwf	tmp1
dsrxlp:

	dqlow
	call	del_10u		;pausa 10us
	dqhiz

	nop		;6us
	nop
	nop
	nop
	nop
	nop

	bcf		STATUS, C
	btfsc	PORTB, dsbit
	 bsf	STATUS, C
	
	rrf		tmp2, F

	call	del_10u		;pausa 60us
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;

	decfsz	tmp1, F
	 goto	dsrxlp
	 
	movf	tmp2,W

	return
























; ---------------------------------------------------------

	;	ds1820 macros

dqlow2:	macro
	bcf		PORTB,dsbit_2; dq bit ready low
	bsf		STATUS,RP0
	bcf		TRISB,dsbit_2; dq bit now o/p
	bcf		STATUS,RP0
	endm


dqhiz2:	macro
	bsf		STATUS,RP0
	bsf		TRISB,dsbit_2	; dq bit now i/p
	bcf		STATUS,RP0
	endm


; ---------------------------------------------------------



; ---------------------------------------------------------


newtemp_2:

	intsoff		;desliga interrupcoes

	clrf	tmp0
	clrf	tmp1
	clrf	tmp2

getemp_2:
	
	call	dsreset_2
	movlw	h'cc'		; skip prom
	call	dstx8_2
	movlw	h'44'		; start convert temperatura
	call	dstx8_2


;; delay de pull-up forcado
	dqlow2				;faz pull-up forcado
	bsf		PORTB,dsbit_2	; dq bit ready HIGH
	bsf		PORTB,dsbit_2	; dq bit ready HIGH
	bsf		PORTB,dsbit_2	; dq bit ready HIGH
	bsf		PORTB,dsbit_2	; dq bit ready HIGH
	bsf		PORTB,dsbit_2	; dq bit ready HIGH
	call	del_500		;pausa de 1seg
	call	del_500	
	dqhiz2				;desfaz pull-up forcado
	
	call	dsreset_2	;outra vez reset
	movlw	h'cc'		; skip prom
	call	dstx8_2
	movlw	h'be'		; read scratch pad
	call	dstx8_2

	call	dsrx8_2		; magnitude
	movwf	dsmag
	call	dsrx8_2		; sign (ff=-ve, 00=+ve)
	movwf	dssign

	call	dsreset_2		; seen enough, restart


fim_1wire_2:
	
	intson		;liga ints

	return













; ------------------------------------------------------------

	;	ds1820 subroutines

dsreset_2:

	dqlow2
	call	del_100u	;pausa de 600us
	call	del_100u
	call	del_100u
	call	del_100u
	call	del_100u
	call	del_100u
	dqhiz2

	call	del_10u		;pausa 70us
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;

	call	del_100u	;pausa de 300us
	call	del_100u
	call	del_100u

	return




dstx8_2:	
	movwf	tmp2		; data to tx
	movlw	8
	movwf	tmp1		; loop counter
dstxlp_2:	

	dqlow2
	call	del_10u		;pausa 10us
	
	rrf		tmp2, F
	btfsc	STATUS,C
	 bsf	PORTB,dsbit_2	; dq hi if bit was 1

	call	del_10u		;pausa 70us
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;
	dqhiz2

	nop		;6us
	nop
	nop
	nop
	nop
	nop

	decfsz	tmp1, F
	 goto	dstxlp_2

	return




dsrx8_2:
	movlw	8
	movwf	tmp1
dsrxlp_2:

	dqlow2
	call	del_10u		;pausa 10us
	dqhiz2

	nop		;6us
	nop
	nop
	nop
	nop
	nop

	bcf		STATUS, C
	btfsc	PORTB, dsbit_2
	 bsf	STATUS, C
	
	rrf		tmp2, F

	call	del_10u		;pausa 60us
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;
	call	del_10u		;

	decfsz	tmp1, F
	 goto	dsrxlp_2
	 
	movf	tmp2,W

	return


